/* Copyright (C) 2000, 2001, 2002 by SWsoft
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

/*  $Id: maps.h,v 1.10 2002/01/09 11:50:14 kir Exp $
    Author : Alexander F. Avdonkin
*/

#ifndef _MAPS_INCLUDED_
#define _MAPS_INCLUDED_

#include "aspseek-cfg.h"
#ifdef HAVE_EXT_HASH_MAP_SET
#include <ext/hash_map>
#include <ext/hash_set>
#else
#include <hash_map>
#include <hash_set>
#endif

#include <string>
#include "defines.h"

using std::string;
using std::hash_map;
using std::hash_set;

namespace std {
	struct hash<string> {
		size_t operator()(const string& __s) const
		{
			return __stl_hash_string(__s.c_str());
		}
	};
}

typedef std::hash_map<string, string> MapStringToString;
typedef std::hash_map<string, int > MapStringToInt;
typedef hash_set<ULONG> CULONGSet;


#endif
